Subject: bug#42655: 27.1; iconify-frame on a Lucid build may stuck the frame

From: Tino Calancha <[email-masked]>
Date: Fri, 07 Aug 2020 16:01:11 +0200

Eli Zaretskii <[email-masked]> writes:

> So in your customized session the patch doesn't really solve the
> problem?  Or did I misunderstand?
Exactly.  My patches fixes _only_ an Emacs -Q session: for me,
it doesn't work in a normal custom session.

>> > Btw, what does "selecting again the hidden frame" mean, exactly?  What
>> > gestures do you use to do that?  And what is your window manager?
>> 
>> [This seems to be a problem affecting only my window manager (GNOME Shell)]
>> 
>> - After C-z, the frame dissapear from the screen.
>> - Note, there is no lower/upper bar with the APP iconified.
>> - To get such a frame again, you can do it in several ways:
>>   1. use shortcut to switch between apps (in my case M-TAB)
>>   2. if you the current focused window is another Emacs frame, then you
>>     can use the shortcut to switch between windows of same app
>>     (in my case M-`)
>>   3. Click upper-left corner menu 'Activities': now you can click in the
>>     'iconified' frame with the mouse
>>   Any of those 1-3 send the MapNotify
>
> Now I'm confused: if MapNotify is sent when you use any of the 3
> methods, then why doesn't the frame redisplay normally?
Sorry, for the confusion.  It redisplay normally in a `emacs -Q` session only.

> Previously
> you said that MapNotify isn't received in this scenario.
I have tested a rich casuistic: MapNotify is never recived in my 'custom
sessions'.

Following tables summarizes the situation:

=== window manager:  GNOME Shell ===

--- unpatched Emacs-27 --- 
                  emacs -Q   custom libs

MapNotify at        never      never
bug?                 yes       yes

--- Emacs-27 with patch --- 
                   emacs -Q   custom libs

MapNotify at       iconify   never
bug?                 no       yes

=== window manager:  Other than GNOME Shell ===

--- unpatched Emacs-27 --- 
                  emacs -Q       custom libs

MapNotify at        de-iconify   de-iconify
bug?                no           no

[In this case patched/unpatched makes no difference]
Except for GNOME Shell, for all win managers that I have tested,
the MapNotify comes always at the moment of de-iconify.

In Summary:
- The bugs happens when Emacs is compiled with Lucid and run in an
  environment using GNOME Shell as window manager.
- The patch works for `emacs -Q`
- The patch doesn't work in my cursom sessions :-(

Possible workarounds for me right row:
  1. Use a different window manager.
  2. Or, compile Emacs with GTK.